package com.landray.kmss.sys.attachment.controller;

import java.io.IOException;
import javax.servlet.ServletException;
import com.landray.kmss.sys.attachment.servlet.UploaderServlet;
import org.springframework.web.bind.annotation.ResponseBody;
import com.landray.kmss.common.dto.HttpResponseWriterWrapper;
import com.landray.kmss.common.dto.HttpRequestParameterWrapper;
import java.util.Map;
import com.landray.kmss.common.rest.util.ControllerHelper;
import com.landray.kmss.web.RestResponse;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletRequest;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.stereotype.Controller;

@Controller
@RequestMapping(value = { "/data/sys-attachment/uploaderServlet" }, method = { RequestMethod.POST })
public class UploaderServletController
{
    private final UploaderServletExtra servlet;
    
    public UploaderServletController() {
        this.servlet = new UploaderServletExtra();
    }
    
    @ResponseBody
    @RequestMapping({ "{gettype}" })
    public RestResponse<?> doPost(@PathVariable final String gettype, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final HttpRequestParameterWrapper reqWrapper = ControllerHelper.buildRequestParameterWrapper(request);
        final HttpResponseWriterWrapper respWrapper = ControllerHelper.buildResponseWriterWrapper(response);
        reqWrapper.putParameter("format", "json");
        reqWrapper.putParameter("gettype", gettype);
        this.servlet.init();
        this.servlet.doPost((HttpServletRequest)reqWrapper, (HttpServletResponse)respWrapper);
        final Object data = ControllerHelper.standardizeResult((Object)respWrapper.getWriteContent());
        if (data instanceof Map) {
            final Map<String, Object> dataMap = (Map<String, Object>)data;
            final Object status = dataMap.get("status");
            if (!"1".equals(status)) {
                final Object msg = dataMap.get("msg");
                return (RestResponse<?>)RestResponse.error(String.valueOf(msg));
            }
        }
        return (RestResponse<?>)RestResponse.ok(data);
    }
    
    public static class UploaderServletExtra extends UploaderServlet
    {
        public void doPost(final HttpServletRequest request, final HttpServletResponse response) throws ServletException, IOException {
            super.doPost(request, response);
        }
    }
}
